//
// Created by ascadian on 12/1/17.
// A server that accepts cameras to send him data.
//

#pragma once

#include <src/Core/StreamCollection.h>
#include "ServerSession.h"

namespace dyncam {

class StreamServer : std::enable_shared_from_this<StreamServer> {

    friend class ServerSession;

public:
    explicit StreamServer(unsigned short port = 4242);

    virtual ~StreamServer();

    void shutdown();

protected:
    int m_port;
    std::thread m_thread;
    void threadMain();

    void acceptConnections();
    boost::asio::io_service m_io_service;
    boost::asio::ip::tcp::endpoint m_endpoint;
    boost::asio::ip::tcp::acceptor m_acceptor;

    std::shared_ptr<StreamCollection> m_streams = std::make_shared<StreamCollection>();

public:
    void AddStream(std::shared_ptr<Stream> s);

    //std::map<std::string, std::shared_ptr<EventSourceT<cv::Mat>>> m_Streams;
    //EventsT <Stream> newStreamEvent =  MakeEventSource<D, Stream>();


//    typedef int CamId_t;
//    std::map<CamId_t, StreamCollector> cams;
};

} // namespace dyncam