//
// Created by ascadian on 11/26/17.
//

#pragma once

#include "../../ReactDomain.h"
#include <opencv2/opencv.hpp>
#include "../BaseCam.h"
#include <atomic>
#include <thread>

#include "src/Core/ImageStream.h"
#include "src/Core/IntrinsicsStream.h"

namespace dyncam {
class TestCam : public BaseCam {

protected:
    // If true, streamThread will continue execution. Will stop executing otherwise.
    std::atomic<bool> m_doProcessing{false};

    std::thread m_streamThread;
    void streamThread();

public:
    std::set<StreamTypes> getStreamCapabilities() override;

    TestCam();
    virtual ~TestCam();

    bool Open() override;
    void Close() override;

    std::shared_ptr<ImageStream> colorStream_;
    std::shared_ptr<ImageStream> depthStream_;
    std::shared_ptr<IntrinsicsStream> intrStream_;
    EventSourceT<cv::Mat> colorSource_ = MakeEventSource<D, cv::Mat>();
    EventSourceT<cv::Mat> depthSource_ = MakeEventSource<D, cv::Mat>();
};

} // namespace dyncam
