//
// Created by ascadian on 8/8/17.
//

#pragma once

#include "../ReactDomain.h"
#include <opencv2/opencv.hpp>
#include "src/Core/Intrinsics.h"
#include "src/Cams/BaseCam.h"
#include "CloudProvider.h"


namespace dyncam {

class CloudFromDepth : public CloudProvider {

public:

    explicit CloudFromDepth(StreamCollection &streams);

protected:

    /* Given pixel coordinates and depth in an image with no distortion or inverse distortion
     * coefficients, compute the corresponding point in 3D space relative to the same camera */
    inline static void rs_deproject_pixel_to_point(const CamIntrinsics &intrin, const bool undistort,
                                                   const int row, const int col,
                                                   const float depth_value,
                                                   float *res);

    static EventsT<cv::Mat >
    transformColor(EventsT<cv::Mat> &color, VarSignalT<CamIntrinsics> &intrinsics, const bool regColor);

    static EventsT<cv::Mat>
    transformDepth(EventsT<cv::Mat> &depth, VarSignalT<CamIntrinsics> &intrinsics, const bool undistort);

    // if there is no undistorted depth, we take care of it
    bool undistort_depth_ = false;
	bool reg_color = false;

};

} // namespace dyncam
