//
// Created by ascadian on 8/21/19.
//

#include "Barrier.h"


void Barrier::count_down() {
    std::unique_lock<std::mutex> lock(_mutex);
    if (--_count == 0) {
        _cv.notify_all();
    }
}

bool Barrier::count_up() {
    std::unique_lock<std::mutex> lock(_mutex);
    if (_count <= 0) {
        return false;
    } else {
        _count++;
        _cv.notify_all();
        return true;
    }
}

void Barrier::count_down_and_wait() {
    std::unique_lock<std::mutex> lock(_mutex);
    if (--_count == 0) {
        _cv.notify_all();
    } else {
        _cv.wait(lock, [this] { return _count == 0; });
    }
}

void Barrier::wait() {
    std::unique_lock<std::mutex> lock(_mutex);
    _cv.wait(lock, [this] { return _count == 0; });
}
