
#include "CoordSystemUnifier.h"



CoordSystemUnifier::CoordSystemUnifier()
{

}

CoordSystemUnifier::~CoordSystemUnifier()
{

}

int CoordSystemUnifier::addTracker(std::shared_ptr<BaseTracker> tracker)
{
    int ret = m_trackers.size();
    m_trackers.push_back( tracker );

    m_currentSystems.push_back( nullptr );
    m_unifyingMatrices.push_back( nullptr );

    return ret;
}

void CoordSystemUnifier::start()
{
    unsigned int i=0;
    for( auto tracker : m_trackers )
    {
        Observe( tracker->m_coordSystemStream, [i, this] ( cv::Matx44d mat )
        {
            if( m_currentSystems.empty() )
                return;

            // delete old data
            if( m_currentSystems[i] )
                delete m_currentSystems[i];

            m_currentSystems[i] = new cv::Matx44d(mat);

            // check if data from all trackers is available
            bool full = true;
            for( auto system : m_currentSystems )
                if( !system )
                {
                    full = false;
                    break;
                }

            // if yes,
            if( full )
            {
                // do the registration
                for( unsigned int i=1; i<m_trackers.size(); ++i )
                {
                    m_unifyingMatrices[0] = new cv::Matx44d( m_currentSystems[i]->inv() ); //TODO correct??
                }
            }
        });
    }
}

void CoordSystemUnifier::stop()
{

}

cv::Matx44d CoordSystemUnifier::getUnifyingMatrix(int trackerID)
{
    return cv::Matx44d::eye();
}
