#ifndef SERVERWINDOW_H
#define SERVERWINDOW_H

#include <QMainWindow>
#include "src/ReactDomain.h"
#include <src/Cams/NetCam/StreamClient.h>

namespace Ui {
class ClientWindow;
}

class ClientWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit ClientWindow(QWidget *parent = nullptr);
    ~ClientWindow() override;

protected:
    Ui::ClientWindow *ui;

    std::map<std::string, EventsT<cv::Mat> *> m_netStreams;
    std::vector<std::unique_ptr<dyncam::StreamClient>> m_netClients;

    void on_connect_clicked();
    void on_request_streams_clicked();
};

#endif // SERVERWINDOW_H
