#include <QtWidgets/QListWidgetItem>
#include <QTimer>
#include <src/UI/Widgets/camerawidget.h>
#include "src/Compression/ColorCompression.h"
#include "src/Compression/QuantizedCompression.h"
#include "src/Compression/Lz4Compression.h"
#include "src/Compression/Lz4QuantCompression.h"
#include "serverwindow.h"
#include "ui_serverwindow.h"

ServerWindow::ServerWindow(QWidget *parent) :
        QMainWindow(parent),
        ui(new Ui::ServerWindow),
        m_pointsMapper(cam->Streams){
    ui->setupUi(this);

    if (cam->Open()) {
        // display all camera streams in one widget
        CameraWidget * camWidget = new CameraWidget(this);
        camWidget->setAllowedAreas(Qt::AllDockWidgetAreas);
        addDockWidget(Qt::RightDockWidgetArea, camWidget);
        resizeDocks({camWidget}, {300}, Qt::Horizontal);
        camWidget->setCam(cam->Streams);

        m_server->AddStream(cam->Streams.GetStreamFirst<ImageStream>(StreamTypes::COLOR));
		m_server->AddStream(cam->Streams.GetStreamFirst<ImageStream>(StreamTypes::REGISTERED_COLOR));
        m_server->AddStream(cam->Streams.GetStreamFirst<ImageStream>(StreamTypes::IR));
        m_server->AddStream(cam->Streams.GetStreamFirst<ImageStream>(StreamTypes::DEPTH));
		m_server->AddStream(cam->Streams.GetStreamFirst<ImageStream>(StreamTypes::UNDISTORTED_DEPTH));
        m_server->AddStream(cam->Streams.GetStreamFirst<IntrinsicsStream>(StreamTypes::INTRINSICS));

    }
}

ServerWindow::~ServerWindow() {
    delete ui;
}