#ifndef SERVERWINDOW_H
#define SERVERWINDOW_H

#include <QMainWindow>
#include <src/Reconstruction/CloudFromDepth.h>
#include "src/ReactDomain.h"
#include "src/Cams/NetCam/StreamServer.h"
#include "src/UI/Widgets/streamwidget.h"
#include "src/Cams/Freenect2/Freenect2Cam.h"

namespace Ui {

class ServerWindow;
}

class ServerWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit ServerWindow(QWidget *parent = nullptr);
    ~ServerWindow() override;

protected:

    Ui::ServerWindow *ui;

    std::shared_ptr<StreamServer> m_server = std::make_shared<StreamServer>();
    std::shared_ptr<BaseCam> cam = std::make_shared<Freenect2Cam>();
    CloudFromDepth m_pointsMapper;

    std::map<std::string, StreamWidget*> m_streamWidgets;
};

#endif // SERVERWINDOW_H
